﻿using System;
using System.Collections.ObjectModel;
using System.ComponentModel;
using System.Runtime.CompilerServices;
using DateTimeColumnStringFormat.Annotations;
using DateTimeColumnStringFormat.Models;

namespace DateTimeColumnStringFormat.ViewModels
{
    public class MainViewModel : INotifyPropertyChanged
    {
        public MainViewModel()
        {
            Students = GenerateStudents();
        }

        private ObservableCollection<Student> GenerateStudents()
        {
            var list = new ObservableCollection<Student>();

            for (int i = 1; i < 4; i++)
            {
                list.Add(new Student
                {
                    Name = $"Student {i}",
                    GraduationDate = DateTime.Now.AddYears(i)
                });
            }

            return list;
        }

        public ObservableCollection<Student> Students { get; set; }

        public event PropertyChangedEventHandler PropertyChanged;

        [NotifyPropertyChangedInvocator]
        protected virtual void OnPropertyChanged([CallerMemberName] string propertyName = null)
        {
            PropertyChanged?.Invoke(this, new PropertyChangedEventArgs(propertyName));
        }
    }
}
